# Exercise 2:  Introduction to R software: data bases and functions

####################################
# 1) Import a Stata file

rm(list=ls())

library(foreign)
e_ex02.dat <- read.dta("e_ex02.dta")
# e_ex02.dat <- read.dta("c:/epidata_course/e_ex02.dta")
write.table(e_ex02.dat, file="e_ex02.dat", row.names=TRUE)

# See the first 5 records
e_ex02.dat[1:5,]

# Get the list of variable names only
names(e_ex02.dat)

# Get information about the structure
str(e_ex02.dat)

table(e_ex02.dat$fq04)

####################################
# 2) Create full unaltered set (515 records)
e_ex02.dat[e_ex02.dat$fq04=="Missing", "fq04"] <- NA
is.na(e_ex02.dat$fq04)
e_ex02_01.dat <- data.frame(e_ex02.dat)

####################################
# 3) Create a subset with records with known FQ DST result (401 records)
e_ex02_02.dat <- e_ex02.dat[which(e_ex02.dat$fq04 != "Missing"), ]
# or alternatively with the SUBSET function:
e_ex02_02.dat <- subset(e_ex02.dat, fq04 != "Missing")

####################################
# 4) Create a subset with records with known FQ resistance and
#  bacteriological success or failure (53 records)
# Commands on three lines
#  e_ex02_03a.dat <- subset(e_ex02_02.dat,  outcome07 != "Death")
#  e_ex02_03b.dat <- subset(e_ex02_03a.dat, outcome07 != "Default")
#  e_ex02_03.dat <- subset(e_ex02_03b.dat, fq04 != "Susceptible")
# Alternatively, commands on single line
e_ex02_03.dat <- subset(e_ex02_02.dat,  outcome07 != "Death" & outcome07 != "Default" & fq04 != "Susceptible")

# Table of outcome by FQ resistance
# Create first a new variable FQ02

attach(e_ex02_02.dat)
e_ex02_02.dat[e_ex02_02.dat$fq04=="Susceptible", "fq02"]           <- "1-Susceptible"
e_ex02_02.dat[e_ex02_02.dat$fq04=="Low-level resistance", "fq02"]  <- "2-Resistant"
e_ex02_02.dat[e_ex02_02.dat$fq04=="High-level resistance", "fq02"] <- "2-Resistant"
e_ex02_fq02.dat <- data.frame(e_ex02_02.dat)
table(e_ex02_fq02.dat$fq02, e_ex02_fq02.dat$outcome02)
detach(e_ex02_02.dat)

write.table(e_ex02_01.dat, file="e_ex02_01.dat", row.names=TRUE)
e_ex02_02.dat  <- data.frame(e_ex02_fq02.dat)
write.table(e_ex02_02.dat, file="e_ex02_02.dat", row.names=TRUE)
write.table(e_ex02_03.dat, file="e_ex02_03.dat", row.names=TRUE)

####################################
# 5) Make functions: 2-by-2 table
# Prepare making a function
# tab2by2 <- function(exposure, outcome) {}
# fix(tab2by2)
# save(tab2by2, file = "tab2by2.r")

attach(e_ex02_fq02.dat)

load("C:/epidata_course/tab2by2.r")
tab2by2(fq02, outcome02)
tab2by2(sex, outcome02)

####################################
# 6) Make functions: 2-by-2-by-2 table / Mantel-Heanszel
# Arrays for a stratification

table(fq02, outcome02, sex)

# ormh <- function(exposure, outcome, startvar) {}
# fix(ormh)
# save(ormh, file = "ormh.r")
ormh(fq02, outcome02, sex)
ormh(fq02, outcome02, cxr02)

####################################
# 7) On restart use LOAD to get the funcions
load("C:/epidata_course/ormh.r")
tab2by2(fq02, outcome02)
load("C:/epidata_course/tab2by2.r")
table(fq02, outcome02, sex)
ormh(fq02, outcome02, sex)

mantelhaen.test(table(fq02, outcome02, sex))
mantelhaen.test
# fix(mantelhaen.test)
